var 
   pie          // inflation rate (1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// high risk enterprise
   r_kh         // capital real rent rate for the high risk enterprise (2)
   u_h          // capital utilization ratio for the high risk enterprise (3)
   R_KH         // real capital return rate of the high risk enterprise (4)
   omegarbar    // critical condition of financial accelerator (5)
   sigma        // shock variation to high risk enterprise (6)
   k_h          //  capital stock for high risk enterprise (7)
   n_h          //  capital stock of high risk enterprise (8)
   b_h          //  high risk enterprise borrowing fund from shandow banking (9)
// shadow banking 
   r_sb         //  lending rate from shadow banking to high risk enterprise (10)
   omegarbar_b  //  posterior watched risk (11)
   chi_sb       //  post event risk change (12)
   n_sb         //  shasow banking equity in period t (13)
//   w_sb 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Low Risk Enterprise
   r_kl         //  capital real rent rate for the low risk enterprise (14)
   R_KL         //  real capital return rate of the low risk enterprise (15)
   u_l          //  capital utilization ratio for the low risk enterprise (16)
   k_l          //  capital stock for low risk enterprise production including borrowing from commercial (17)
   n_l          //  net total capital (18)
   b_l          //  low risk enterprise borrowing fund from commercial bank (19)
// commercial bank system
   r_bl         // lending rate to low risk enterprise from branch bank (20)
   epsilon_rl   // substitution elasticity of branch bank (21)
   profit_b     // commercial bank profit (22)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// intermediate products enterprise
   y            // total social (23)
   k            // total capital (24)
   w            // real wage (25)
   s            // marginal cost (26)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// capital producer
   i            // investment (27)
   q            // capital price (28)
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// calvo sticky price  
   pstar        // optimal price (29)
   Fp           // proxy variable 1  (30)
   Kp           // proxy variable 2  (31)
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// represent household
   c            // comsumption (32)
   lambda       // langrange multiplier (33)
   D            // deposit to commercial bank (34)
   h            // labor supply (35)
   r_e          //  financial product yield to family (36)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// calvo sticky wage 
   wstar        // optimal wage (37)
   Fw           // proxy variable 1 (38)
   Kw           // proxy variable 1 (39)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// central bank 
   r            // deposite rate (40)
// entire variable 
   lev_h        // high risk enterprise leverage (41)
   lev_l        // low risk enterprise leverage (42)
   soc_lev      // the whole sociaty leverage (43)
   TSF         // total social financing (44)
// observable variable 
   y_obs
   c_obs;

varexo eps_sigma eps_rlshock eps_rd;

parameters
     beta         // discount factor
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// high risk enterprise
     r_kh_ss        // rate of return on high risk enterprise capital
     delta_h        // capital depreciation of high risk enterprise
     sigmaa_h       // cavature of high risk enterprise cost function
     miu            // liquidation cost of shadow banking
     gamma_h        // high risk enterprise default rate
     sigma_ss       // steady state of high risk enterprise idiosycratic prodcution shock
     rho_sigma      // AR(1) coefficient for sigma
     w_h            // transfer capital to high risk enterprise from represent family 
// shadow banking
     rho_chi_sb     // AR(1) coefficient for chi_sb
     alpha_sb       // reaction coefficient to v_h - steady_state(v_h)
     alpha1         // shadow banking default paremeters 1 
     alpha2         // shadow banking default paremeters 2
     delta_sb       // shadow banking default stadard deviaton
     w_sb           // transfer capital to shadow banking from represent family 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Low Risk Enterprise
     r_kl_ss        //  rate of return on low risk enterprise capital
     sigmaa_l       // carvature of the cost function for low risk enterprise
     delta_ll       // capital depreciation of low risk enterprise
     gamma_l        // low risk enterprise survival rate
     w_l            // transfer to low risk enterprise from family
// commercial bank system
     v              // deposit reserve rate of commercial bank       
     epsilon_rlss   // steady state of epsilon_rl(substitution elasticity of branch bank)
     phi_rly        // reaction coefficient to social product of epsilon_rl
     eta_cost       // commerciala bank cost parameter
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// intermediate produciton
     alpha          // output elasticity of capital
     eta            // proportionality coefficient of high risk enterprise capital to social capital
     rho            // substitution elasticity between high risk capital to low risk capital
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// calvo sticky price  
     xip           // probability of price can't adjsutment every period
     pietarget     // inflation target (pietarget=1) 
     lambdaf       // reflecting intermediate products substitution elasticity 
     iota          // inflation index for the previous period
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// capital producer
     kappa_i       // marginal investment adjustment cost
     delta         // capital discount rate
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// represent household
     phi_l        // utility coefficient to household labor supply
     delta_l      // substitution elasticity of labor
     b            // consumption inertia coefficient
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// calvo sticky wage 
     xiw          // probability of wage can't adjsutment every period
     lambdaw      // reflecting wage makeup
     iotaw        // wage inflation index for the previous period     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// resource constraint
     etag         // propotion to government expenditure to total social output 
     rho_rd       // interest rate smoothing coefficient 
     phi_rpie     // reaction coefficient of interest rate to inflation
     phi_ry       // reaction coefficient of interest rate to total social product 
// central bank monetary policy including deposit rate
     r_ss;        // steady state of deposit rate 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   beta          =    0.9925;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// high risk enterprise
   r_kh_ss       =    0.07; 
   delta_h       =    0.03;
   sigmaa_h      =    18.9;
   sigma_ss      =    0.65;
   miu           =    0.3;
   rho_sigma     =    0.8;
   gamma_h       =    0.05;
   w_h           =    0.14;
// shadow banking
   rho_chi_sb    =    0.8;
   alpha_sb      =    0.9; 
   alpha1        =    0.4;
   alpha2        =    0.97;
   delta_sb      =    0.2;
  w_sb          =    0.116282119029118;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// low risk enterprise
   sigmaa_l      =    18.9;
   delta_ll      =    0.025;
   gamma_l       =    0.03;
   r_kl_ss       =    0.045;
   w_l           =    1.12;
// commercial bank system
   v             =    0.2;
   epsilon_rlss  =    207.1855670103084; 
   phi_rly       =    9;
   eta_cost      =    0.6;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// intermediate produciton
   alpha         =    0.6;
   eta           =    0.16;
   rho           =    0.71; 
// calvo sticky price 
   lambdaf       =    1.199129448472893; 
   xip           =    0.8;
   pietarget     =    1;
   iota          =    0;
// capital producer
   kappa_i       =    2.5;
   delta         =    0.03;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// represent family  
   phi_l         =    14.129780032855374; 
   delta_l       =    1;
   b             =    0.8;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// calvo sticky wage
   xiw           =    0.75; 
   lambdaw       =    1.05;
   iotaw         =    0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// resource constraint
    etag         =    0.135;
// central bank monetary policy including deposit rate
    rho_rd       =    0.8;
    r_ss         =    1 / beta - 1;          
    phi_rpie     =    1.2;
    phi_ry       =    0.4;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


model;
// Auxiliary expressions, these simplify the equations without adding additional variables.
   #   a_h      =    r_kh_ss * ( exp( sigmaa_h * ( u_h - 1 ) ) - 1 ) / sigmaa_h ;     // a_h is cost function for high risk enterprise
   #   a_l      =   ( r_kl_ss * ( exp( sigmaa_l * ( u_l-1 ) ) - 1 ) / sigmaa_l );     // cost function for the low risk enterprise
   #   gamma    =    omegarbar * ( 1 - normcdf( ( ( log( omegarbar ) + sigma^2 / 2 ) / sigma ) ) ) + normcdf( ( ( log( omegarbar ) + sigma^2 / 2 ) / sigma ) - sigma );                        
   #   G        =    normcdf( ( ( log( omegarbar ) + sigma^2 / 2 ) / sigma ) - sigma );
   #   gamma_derivative    =    ( 1 - normcdf( ( log( omegarbar )  + sigma^2 / 2 ) / sigma ) ) ;
   #   G_derivative        =    omegarbar * ( normpdf( ( log( omegarbar ) + sigma^2 / 2 ) / sigma ) / omegarbar / sigma );
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// high risk enterprise

   r_kh    =     r_kh_ss * exp( sigmaa_h *( u_h - 1 ) ); // capital utilization (1)   

   R_KH    =     pie * ( ( u_h * r_kh - a_h ) + ( 1 - delta_h ) * q ) / q(-1) - 1; // rate of return on capital (2)

   ( 1 - gamma ) * ( ( 1 + R_KH ) / ( 1 + r_e ) ) +  ( gamma_derivative / ( gamma_derivative - miu * G_derivative ) ) * ( ( ( 1 + R_KH ) / ( 1 + r_e ) ) * ( gamma - miu * G ) - 1 ) = 0; // r_e(+1) standard debt contract for high risk enterprise (3)

   q(-1) * k_h * ( 1 + R_KH ) * ( gamma - miu * G ) = q(-1) * k_h * ( 1 + r_e ) - n_h * ( 1 + r_e ); // r_e(+1) zero profit condition (4)                                               
   
   n_h     =     ( 1 - gamma_h ) * ( R_KH - r_e - miu * normcdf( ( log( omegarbar ) + sigma^2/2 ) / sigma - sigma ) * ( 1 + R_KH ) ) * q(-1) * k_h + ( 1 - gamma_h ) * ( 1 + r_e ) * n_h(-1) / pie + w_h; // r_e(-1) law of motion for net worth for high risk enterprise (5)
  
   sigma   =     ( 1 - rho_sigma ) * sigma_ss + rho_sigma * sigma(-1) + eps_sigma; // (6)
  
   b_h     =     q(-1) * k_h - n_h; // (7)

// shadow banking

  ( 1 -  normcdf( ( log( omegarbar )  + sigma^2 / 2 ) / sigma ) ) * ( 1 + r_sb ) * b_h + ( 1 - miu ) * normcdf( ( ( log( omegarbar ) + sigma^2 / 2 ) / sigma ) - sigma )  * ( 1 + R_KH ) * q(-1) * k_h = ( 1 + r_e ) * b_h; // (8)   
 
   omegarbar_b   =    omegarbar * ( 1 + chi_sb ); // (9)

   chi_sb        =    rho_chi_sb * chi_sb(-1) + ( 1 - rho_chi_sb ) * alpha_sb * ( n_h - steady_state(n_h) ); // (10)
  
   n_sb          =    ( 1 - ( 0.112 + 12 * normcdf( ( - alpha1 - alpha2 * ( n_sb / b_h ) ) / delta_sb ) ) ) * n_sb(-1) + ( 1 - normcdf( ( log(omegarbar_b) + sigma^2 / 2 ) / sigma ) ) * ( 1 + r_sb ) * b_h
                      + ( 1 - miu ) * ( 1 + R_KH ) * q(-1) * k_h * ( normcdf ( ( log(omegarbar_b) + sigma^2 / 2 ) / sigma - sigma ) ) - ( 1 + r_e ) * b_h + w_sb; // (11)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// low risk enterprise

   r_kl          =   r_kl_ss * exp( sigmaa_l * ( u_l - 1 ) ); // (12)

   r_bl - R_KL - 1 + ( 1 / beta ) = 0; // (13)

   R_KL          =   pie * ( ( u_l * r_kl - a_l ) + ( 1 - delta_ll ) * q ) / q(-1) - 1; // (14)

   n_l           =   q * k_l / pie * ( 1 - gamma_l ) * ( R_KL - r_bl(-1) ) + ( 1 - gamma_l ) / pie * ( 1 + r_bl(-1) ) *  n_l(-1) + w_l; // (15) 

   b_l           =   q(-1) * k_l - n_l; // (16)

// commercial bank system

   r_bl          =   ( epsilon_rlss / ( epsilon_rlss - 1 ) ) * ( 1 + r ) - 1; // (17)

   epsilon_rl    =    epsilon_rlss + phi_rly * ( y - steady_state(y) ) + eps_rlshock; // (18) 

   b_l           =    ( 1 - v ) * D ; // (19)

   profit_b      =    r_bl * ( 1 - eta ) * b_l - r * ( ( 1 - eta ) * D ); // (20)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// intermediate products enterprise 

   y             =      ( k(-1)^alpha ) * ( h^( 1 - alpha ) ); // (21)

   k             =      ( eta * ( u_h * k_h )^rho + ( 1 - eta ) * ( u_l * k_l )^rho )^( 1 / rho ); // (22)

   r_kh / r_kl   =      ( ( u_h * k_h ) / ( u_l * k_l ) )^( rho - 1 ); // (23)

   s             =      ( rho / ( rho + alpha * ( 1 - rho ) ) ) * ( ( w / ( 1 - alpha ) )^( 1 - ( alpha / ( rho + alpha * ( 1 - rho ) ) ) ) ) * ( ( ( alpha / r_kh ) * ( ( k_h )^( rho - 1 ) ) )^( - alpha / ( rho + alpha * ( 1 - rho ) ) ) ) * ( ( y )^( alpha * ( rho - 1 ) / ( rho + alpha * ( 1 - rho ) ) ) ); // (24)                                                     

   s             =      r_kh / ( alpha * ( ( h / k )^( 1 - alpha ) ) * ( ( u_h * k_h )^( rho - 1 ) ) * ( ( eta * ( u_h * k_h )^rho + ( 1 - eta ) * ( u_l * k_l )^rho )^( ( 1 / rho ) -1 ) ) ); // (25)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// calvo sticky price  

   pstar          =      ( ( 1 - xip ) * ( ( 1 - xip * ( ( pietarget^( iota ) * ( pie(-1)^( 1 - iota ) ) / pie )^( 1 / ( 1 - lambdaf ) ) ) ) / ( 1 - xip ) )^( lambdaf ) + xip * ( ( ( pietarget^( iota ) * pie(-1)^( 1 - iota ) ) / pie ) * pstar(-1) )^( lambdaf / ( 1 - lambdaf ) ) )^( ( 1 - lambdaf ) / lambdaf ); //(26)

   Fp             =      lambda * y + beta * xip * ( ( ( pietarget^( iota ) *  pie^( 1 - iota ) ) / pie(+1) )^( 1 / ( 1 - lambdaf ) ) ) * Fp(+1); // (27)

   Kp             =      lambda * lambdaf * s * y + beta * xip * ( ( pietarget^( iota ) * pie^( 1 - iota ) ) / pie(+1) )^( - lambdaf / ( lambdaf - 1 ) ) * Kp(+1); // (28)

   Kp             =      Fp * ( ( 1 - ( xip * ( ( pietarget^( iota ) * pie(-1)^( 1 - iota ) ) / pie )^( 1 / ( 1 - lambdaf ) ) ) ) / ( 1 - xip ) )^( 1 - lambdaf ); //(29)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// capital producer

   lambda * q * ( 1 - kappa_i / 2 * ( ( i / i(-1) - 1 )^2 )- kappa_i * ( i / i(-1) )* ( i / i(-1) - 1) ) - lambda + beta * lambda(+1) * q(+1) * kappa_i * ( ( i(+1) / i )^2 )* ( i(+1) / i - 1 ) = 0; // (30)

   ( eta *  u_h * k_h + ( 1 - eta ) * u_l * k_l ) = ( 1 - delta ) * ( eta *  ( u_h(-1) * k_h(-1) ) + ( 1 - eta ) * ( u_l(-1) * k_l(-1) ) ) + ( 1 - kappa_i / 2 * ( i / i(-1) - 1 )^2 ) * i; // (31)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// represent household
  
   lambda         =     1 / ( c - b * c(-1) ) - beta * b / ( c(+1) - b * c ); // (32)
  
   lambda         =     beta * ( 1 + r(+1) ) * lambda(+1) / pie; // (33)

   lambda         =     beta * ( 1 + r_e(+1) ) * ( 1 - normcdf( ( - alpha1 - alpha2 * ( n_sb / b_h ) ) / delta_sb ) ) * lambda(+1) / pie; // (34)

  // c + ( 1 - eta ) * D + eta *  b_h + etag * y + ( 1 - eta ) * w_l + eta * w_h + w_sb = w * h + ( 1 + r ) * eta * D(-1) / pie + ( 1 + r_e ) * ( 1 - normcdf( ( -alpha1- alpha2 * ( n_sb / b_h ) ) / delta_sb ) ) * eta * b_h(-1) / pie + ( 1 - eta ) * gamma_l * n_l + eta * gamma_h * n_h + ( 0.112 + 12 * normcdf( ( - alpha1 - alpha2 * ( n_sb / b_h ) ) / delta_sb ) ) * n_sb + ( 1 - eta_cost ) * profit_b; //(25)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// calvo sticky wage
 
   wstar           =     ( ( 1 - xiw ) * ( ( 1 - xiw * ( ( pietarget^( iotaw ) * pie(-1)^( 1 - iotaw ) ) / ( pie * w / w(-1) ) )^( 1 / ( 1 - lambdaw ) ) ) / ( 1 - xiw ) )^( lambdaw ) + xiw * ( ( ( pietarget^( iotaw ) * pie(-1)^( 1 - iotaw ) ) / ( pie * w / w(-1) ) ) * wstar(-1) )^( lambdaw / ( 1 - lambdaw ) ) )^( ( 1 - lambdaw ) / lambdaw ); // (35)

   ( wstar^( lambdaw / ( lambdaw -1 ) ) ) * h * lambda / lambdaw + beta * xiw * ( ( pietarget^( iotaw ) * ( pie(-1)^( 1 - iotaw ) ) )^( 1 / ( 1 - lambdaw ) ) / pie(+1) ) * ( ( 1 / ( pie(+1) * w(+1) / w ) )^( lambdaw / ( 1 - lambdaw ) ) ) * Fw(+1) - Fw = 0; // (36)

   ( wstar^( lambdaw / ( lambdaw -1 ) ) * h )^( 1 + delta_l ) + beta * xiw * ( ( ( pietarget^( iotaw ) * ( pie(-1)^( 1 - iotaw ) ) ) / ( pie(+1) * w(+1) / w ) )^( lambdaw / ( 1 - lambdaw ) * ( 1 + delta_l ) ) ) * Kw(+1) - Kw =0; // (37) 

   ( 1 / phi_l ) * ( ( 1 - xiw * ( ( pietarget^( iotaw ) * ( pie(-1)^( 1 - iotaw ) ) ) / ( pie * w / w(-1) ) )^( 1 / ( 1 - lambdaw ) ) ) / ( 1 - xiw ) )^( 1 - lambdaw * ( 1 + delta_l ) ) * w * Fw - Kw = 0; // (38)

// resource constraint
  
    c + i + etag * y + eta * miu * ( 1 + R_KH ) * normcdf( ( ( log( omegarbar ) + sigma^2 / 2 ) / sigma ) - sigma ) * q(-1) * k_h + eta * a_h * k_h + ( 1 - eta ) * a_l * k_l + ( 1 - eta_cost ) * profit_b = y; // (39)

// central bank monetary policy 

   r              =      rho_rd * r(-1) + ( 1 - rho_rd ) * ( r_ss + phi_rpie * ( pie - steady_state(pie) ) + phi_ry * ( ( y - steady_state(y) ) / y ) ) + eps_rd; // (40)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// entire variable 
   lev_h          =  q * k_h / n_h; // (41)
   
   lev_l          =  q * k_l / n_l; // (42)
 
   soc_lev        =  eta * lev_h + ( 1 - eta ) * lev_l; // (43)

   TSF            =  eta * b_h + ( 1 - eta ) * b_l; // (44)

// observable variable equations
   y_obs          = log(y) - log(steady_state(y));
   c_obs          = log(c) - log(steady_state(c));
//   pie_obs        =  pie - steady_state(pie);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end;

varobs y_obs c_obs ;

initval;
   r_e           =      0.015; // (1)  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// high risk enterprise
   r_kh          =      r_kh_ss; // (2)
   u_h           =      1; // (3)
   q             =      1; // (4)
   R_KH          =      r_kh - delta_h; // (5)
   sigma         =      sigma_ss; // (6)
   omegarbar     =      0.230648545301527; // (7)
   k_h           =      27.409417048714833; // (8)
   n_h           =      21.008063698336578; // (9)
   b_h           =      q * k_h - n_h; // (10)
// shadow banking
   omegarbar_b   =      omegarbar; // (11)
   chi_sb        =      0; // (12)
   r_sb          =      ((1+r_e)*b_h-(1-miu)*normcdf(((log(omegarbar)+sigma^2/2)/sigma)-sigma)*(1+R_KH)*q*k_h)/((1-normcdf((log(omegarbar)+sigma^2/2)/sigma))*b_h)-1; // (13)
   n_sb          =      0.581410883718849; // (14)
//   w_sb          =    0.116282119029118;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// low risk enterprise
   r_kl          =      r_kl_ss; // (15)
   u_l           =      1; // (16)
   R_KL          =      r_kl - delta_ll; // (17)
   r_bl          =      1 + R_KL - ( 1 / beta ); // (18)
   k_l           =      ( ( r_kh / r_kl )^( 1 / ( 1 - rho ) ) ) * ( k_h * u_h ) / u_l; // (19)
   n_l           =      ( k_l * ( 1 - gamma_l ) * ( R_KL - r_bl ) + w_l ) / ( 1 - ( 1 - gamma_l ) * ( 1 + r_bl ) ); // (20)
   b_l           =      q * k_l - n_l; // (21)
// commercial bank system
   epsilon_rl    =      epsilon_rlss; // (22)
   D             =      b_l / ( 1 - v ); // (23)
   profit_b      =      r_bl * ( 1 - eta ) * b_l - r_ss * ( 1 - eta ) *  D; // (24)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// capital producer
   k             =      ( eta * ( u_h  *  k_h )^rho + ( 1 - eta ) * ( ( u_l * k_l )^rho ) )^( 1 / rho ); // (25)
   i             =      delta * ( eta * ( u_h * k_h ) + ( 1 - eta ) * ( u_l * k_l ) );  // (26)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// intermediate products enterprise
   s             =      1 / lambdaf; // (27)
   h             =      0.292139066660454; // (28)
   w             =      22.849056125573080; // (29)
   y             =      k^alpha * h^( 1 - alpha ) ; // (30)
// represent family 
   c             =      ( 1 - etag ) * y - i - miu * eta * ( normcdf ( ( log(omegarbar) + sigma^2 / 2 ) / sigma - sigma ) ) * ( 1+ R_KH ) * q * k_h   - ( 1 - eta_cost ) * profit_b; // (31)
   lambda        =      ( 1 - beta * b ) / ( ( 1 - b ) * c ); // (32)
// calvo sticky price 
   pstar         =      1; //(33)
   Fp            =      lambda * y / ( 1 - beta * xip ); // (34)
   Kp            =      Fp; // (35) 
   pie           =      pietarget; // (36)
// calvo sticky wage 
   wstar         =      1; // (37)
   Fw            =      ( h * lambda / lambdaw ) / ( 1 - beta * xiw ); // (38)
   Kw            =      h^( 1 + delta_l) / ( 1 - beta * xiw ); // (39)
// central bank monetary policy
   r             =      r_ss; // (40)
// entire variable 
   lev_h          =     q * k_h / n_h; // (41)
   lev_l          =     q * k_l / n_l; // (42)
   soc_lev        =     eta * lev_h + ( 1 - eta ) * lev_l; // (43)
   TSF            =     eta * b_h + ( 1 - eta ) * b_l; // (44)
end;

resid(1);
steady(solve_algo=1);
check;
model_diagnostics;

estimated_params;
// high risk enterprise
   sigmaa_h,gamma_pdf,18.9,5;
   rho_sigma,beta_pdf,0.8,0.1;
// shadow banking
   rho_chi_sb,beta_pdf,0.8,0.1; 
   alpha_sb,gamma_pdf,20,5;
// low risk enterprise
   sigmaa_l,gamma_pdf,18.9,5;
   phi_rly,gamma_pdf,20,5;
// capital producer
   kappa_i,gamma_pdf,2.5,1; 
// represent household
//   delta_l,gamma_pdf,1,1;
 //  b,beta_pdf,0.8,0.1;
// calvo sticky price 
 //  xip,beta_pdf,0.8,0.1;
// calvo sticky wage
   xiw,beta_pdf,0.75,0.1;
// central bank monetary policy 
   rho_rd,beta_pdf,0.8,0.1;
   phi_rpie,gamma_pdf,1.2,0.4;
   phi_ry,gamma_pdf,0.5,0.3;

//   stderr eps_sigma, inv_gamma_pdf, 0.01, 0.005;
//   stderr eps_rlshock, inv_gamma_pdf, 0.01, 0.005;
   stderr eps_rd, inv_gamma_pdf, 0.01, 0.005;
end;

estimation(datafile=data1,nograph,mh_replic=5000,mh_drop=0.5,mh_jscale=0.25,diffuse_filter,mode_check,mode_compute=4,smoother);